#ifndef	PEXEXTLIBINT_H
#define	PEXEXTLIBINT_H

/* Common Open Systems Environment, Common Graphics Environment  */		
/* Extension to PEX 5.1 version 2.  File date: March 30, 1994    */		

/******************************************************************************/
/*  (c)	Copyright Hewlett-Packard Company, 1993,  Fort Collins,	Colorado      */
/*									      */
/*  (C)	COPYRIGHT International	Business Machines Corp.	1993		      */
/*									      */
/*   Copyright (c) 1993	by Sun Microsystems, Inc.			      */
/*									      */
/*			      All Rights Reserved			      */
/*									      */
/*  Permission to use, copy, modify, and distribute this software and its     */
/*  documentation for any purpose and without fee is hereby granted,	      */
/*  provided that the above copyright notices appear in	all copies and that   */
/*  both the copyright notices and this	permission notice appear in	      */
/*  supporting documentation, and that the names of Hewlett-Packard,	      */
/*  International Business Machines, or	Sun Microsystems not be	used in	      */
/*  advertising	or publicity pertaining	to distribution	of the software	      */
/*  without specific, written prior permission.				      */
/*									      */
/*  HEWLETT-PACKARD MAKES NO WARRANTY OF ANY KIND WITH REGARD TO THIS	      */
/*  SOFTWARE, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF	      */
/*  MERCHANTABILITY AND	FITNESS	FOR A PARTICULAR PURPOSE.  Hewlett-Packard    */
/*  shall not be liable	for errors contained herein or direct, indirect,      */
/*  special, incidental	or consequential damages in connection with the	      */
/*  furnishing,	performance or use of this software.			      */
/*									      */
/*  INTERNATIONAL BUSINESS MACHINES CORPORATION	PROVIDES THIS MATERIAL	      */
/*  "AS	IS" WITHOUT WARRANTY OF	ANY KIND, EITHER EXPRESSED OR IMPLIED,	      */
/*  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY  */
/*  AND	FITNESS	FOR A PARTICULAR PURPOSE.				      */
/*									      */
/*  SUN	MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES WITH REGARD	TO THIS	      */
/*  SOFTWARE, INCLUDING	ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,*/
/*  IN NO EVENT	SHALL SUN MICROSYSTEMS,	INC. BE	LIABLE FOR ANY SPECIAL,	      */
/*  INDIRECT OR	CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER	RESULTING     */
/*  FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,      */
/*  NEGLIGENCE OR OTHER	TORTIOUS ACTION, ARISING OUT OF	OR IN CONNECTION      */
/*  WITH THE USE OR PERFORMANCE	OF THIS	SOFTWARE.			      */
/*									      */
/******************************************************************************/

#include "PEXExtproto.h"



/* -------------------------------------------------------------------------
 * Texel related macros.
 * ------------------------------------------------------------------------- */

/* 
 * Protocol texel size based on	texel type (in bytes).
 */

#define	GetTexelSize(_type) \
    ((_type) ==	PEXExtTexelLuminanceFloat ? SIZEOF (pexExtTexelLuminance) : \
    ((_type) ==	PEXExtTexelLuminanceInt8 ? SIZEOF (pexExtTexelLuminance8) : \
    ((_type) ==	PEXExtTexelLuminanceInt16 ? SIZEOF (pexExtTexelLuminance16) : \
    ((_type) ==	PEXExtTexelLuminanceAlphaFloat ? SIZEOF	(pexExtTexelLuminanceAlpha) : \
    ((_type) ==	PEXExtTexelLuminanceAlphaInt8 ?	SIZEOF (pexExtTexelLuminanceAlpha8) : \
    ((_type) ==	PEXExtTexelLuminanceAlphaInt16 ? SIZEOF	(pexExtTexelLuminanceAlpha16) :	\
    ((_type) ==	PEXExtTexelRGBFloat ? SIZEOF (pexExtTexelRGB) :	\
    ((_type) ==	PEXExtTexelRGBInt8 ? SIZEOF (pexExtTexelRGB8) :	\
    ((_type) ==	PEXExtTexelRGBInt16 ? SIZEOF (pexExtTexelRGB16)	: \
    ((_type) ==	PEXExtTexelRGBAlphaFloat ? SIZEOF (pexExtTexelRGBAlpha)	: \
    ((_type) ==	PEXExtTexelRGBAlphaInt8	? SIZEOF (pexExtTexelRGBAlpha8)	: \
    ((_type) ==	PEXExtTexelRGBAlphaInt16 ? SIZEOF (pexExtTexelRGBAlpha16) : \
	0))))))))))))

/*
 * Client texel size based on texel type (in bytes).
 */

#define GetClientTexelSize(_type) \
    ((_type) ==	PEXExtTexelLuminanceFloat ? sizeof (PEXExtTexelLuminance) : \
    ((_type) ==	PEXExtTexelLuminanceInt8 ? sizeof (PEXExtTexelLuminance8) : \
    ((_type) ==	PEXExtTexelLuminanceInt16 ? sizeof (PEXExtTexelLuminance16) : \
    ((_type) ==	PEXExtTexelLuminanceAlphaFloat ? sizeof	(PEXExtTexelLuminanceAlpha) : \
    ((_type) ==	PEXExtTexelLuminanceAlphaInt8 ?	sizeof (PEXExtTexelLuminanceAlpha8) : \
    ((_type) ==	PEXExtTexelLuminanceAlphaInt16 ? sizeof	(PEXExtTexelLuminanceAlpha16) : \
    ((_type) ==	PEXExtTexelRGBFloat ? sizeof (PEXExtTexelRGB) : \
    ((_type) ==	PEXExtTexelRGBInt8 ? sizeof (PEXExtTexelRGB8) : \
    ((_type) ==	PEXExtTexelRGBInt16 ? sizeof (PEXExtTexelRGB16) : \
    ((_type) ==	PEXExtTexelRGBAlphaFloat ? sizeof (PEXExtTexelRGBAlpha) : \
    ((_type) ==	PEXExtTexelRGBAlphaInt8	? sizeof (PEXExtTexelRGBAlpha8) : \
    ((_type) ==	PEXExtTexelRGBAlphaInt16 ? sizeof (PEXExtTexelRGBAlpha16) : \
	0))))))))))))

/* 
 * Count of texels in a list of texel arrays.
 */

#define	GetTexelCount(_domain, _texelArrays, _startLevel, _stopLevel, _texelCount) \
{ \
    unsigned short int _i; \
    unsigned long _texelIncrement; \
\
    _texelCount = 0; \
\
    for (_i = (_startLevel); _i < (unsigned short) (_stopLevel); _i++) \
    {\
       _texelIncrement = (_domain == PEXExtTMDomainColor1D ? \
                            _texelArrays[_i].dimension.t0 : \
                         (_domain == PEXExtTMDomainColor2D ? \
                            _texelArrays[_i].dimension.t0 * \
                            _texelArrays[_i].dimension.t1 : \
                         (_texelArrays[_i].dimension.t0 * \
                            _texelArrays[_i].dimension.t1 * \
                            _texelArrays[_i].dimension.t2 ))); \
       _texelCount += (_texelIncrement > 0) ? _texelIncrement : 0; \
    }\
}



/* -------------------------------------------------------------------------
 * Ext Constants
 * ------------------------------------------------------------------------- */

/*
 * Protocol data structure sizes.  SIZEOF (rec)	== sz_rec.
 */

#define	sz_pexExtGetPipelineContextReply		20
#define	sz_pexExtGetRendererAttributesReply		20
#define	sz_pexExtGetPipelineContextReq		20
#define	sz_pexExtChangePipelineContextReq		20
#define	sz_pexExtChangeRendererReq		16
#define	sz_pexExtGetRendererAttributesReq		16
#define	sz_pexExtTMPerspectiveCorrection		8
#define	sz_pexExtTMSampleFrequency	      8
#define	sz_pexExtTMResourceHints		8
#define	sz_pexExtPrimitiveAA		8
#define	sz_pexExtLineCap		8
#define	sz_pexExtLineJoin		8
#define	sz_pexExtActiveTextures		8
#define	sz_pexExtBFActiveTextures	  8
#define	sz_pexExtFillAreaSetWithData		20
#define	sz_pexExtTriangleStrip		16
#define	sz_pexExtQuadrilateralMesh		20
#define	sz_pexExtSetOfFillAreaSets		28
#define	sz_pexExtEllipse		40
#define	sz_pexExtEllipticalArc		48
#define	sz_pexExtEllipticalArc2D		36
#define	sz_pexExtEllipse2D		28
#define	sz_pexExtCircle2D		16
#define	sz_pexExtCircularArc2D		24
#define	sz_pexExtVendorExtOC			8
#define	sz_pexExtParmProjectedPlane		24
#define	sz_pexExtParmProjectedData		68
#define	sz_pexExtTexelLuminanceAlpha		8
#define	sz_pexExtTexelLuminanceAlpha8		4
#define	sz_pexExtTexelLuminanceAlpha16		4
#define	sz_pexExtTexelLuminance			4
#define	sz_pexExtTexelLuminance8		4
#define	sz_pexExtTexelLuminance16		4
#define	sz_pexExtTexelRGBAlpha			16 
#define	sz_pexExtTexelRGBAlpha8			4
#define	sz_pexExtTexelRGBAlpha16		8
#define	sz_pexExtTexelRGB			12 
#define	sz_pexExtTexelRGB8			4
#define	sz_pexExtTexelRGB16			8
#define	sz_pexExtTexelDimension			8
#define	sz_pexExtTexelArray			8
#define	sz_pexExtTMBindingEntry			12
#define	sz_pexExtTMCoordSourceEntry	        68 
#define	sz_pexExtTMCompositionEntry		4
#define	sz_pexExtTMSamplingEntry		12
#define	sz_pexExtCreateTMData			20	
#define	sz_pexExtCreateTMDescriptionData	20	
#define	sz_pexExtCreateTMExtraDataData		4
#define	sz_pexExtParamData			 4
#define	sz_pexExtParmLinear			32
#define	sz_pexExtParmReflect			64
#define	sz_pexExtTextureMap			 4
#define	sz_pexExtFreeTMData			4
#define	sz_pexExtFreeTMDescriptionData		4
#define	sz_pexExtQueryColorApproxData		 8
#define	sz_pexExtQueryColorApproxReplyData		20
#define	sz_pexExtGetTableEntryReq			12
#define	sz_pexExtGetTableEntriesReq			12
#define	sz_pexExtSetTableEntriesReq			12
#define	sz_pexExtGetTableEntryReply			20
#define	sz_pexExtGetTableEntriesReply			20
#define	sz_pexExtFetchElementsReq			24
#define	sz_pexExtFetchElementsReply			20

/* for other things */
#define	sz_PEXFLOAT				  4



/* -------------------------------------------------------------------------
 * Ext Function	prototypes for PEXlib internal functions.
 * -----------------------------------------------------------------------*/   

extern void _PEXExtOCListOfVertex(
#if NeedFunctionPrototypes
    Display *			/* display */,
    int				/* count */,
    int				/* colorType */,
    int				/* vertFPDataSize */,
    unsigned int		/* vertAttr */,
    PEXExtArrayOfVertex		/* vertData */,
    int				/* fpFormat */
#endif
);

extern void _PEXExtOCListOfTexel(
#if NeedFunctionPrototypes
    Display *			/* display */,
    int				/* count */,
    int				/* colorType */,
    PEXArrayOfColor		/* colors */,
    int				/* fpFormat */
#endif
);

extern void _PEXExtStoreListOfVertex(
#if NeedFunctionPrototypes
    int				/* count */,
    int				/* colorType */,
    int				/* vertFPDataSize */,
    unsigned int		/* vertAttr */,
    PEXExtArrayOfVertex		/* vertData */,
    char **			/* bufPtr */,
    int				/* fpFormat */
#endif
);

extern void _PEXExtStoreListOfTexel(
#if NeedFunctionPrototypes
    int				/* count */,
    int				/* texelType */,
    char *			/* texels */,
    char **			/* bufPtr */,
    int				/* fpFormat */
#endif
);

extern void _PEXExtExtractListOfVertex(
#if NeedFunctionPrototypes
    int				/* count */,
    char **			/* bufPtr */,
    int				/* colorType */,
    int				/* vertFPDataSize */,
    unsigned int		/* vertAttr */,
    PEXExtArrayOfVertex		/* vertData */,
    int				/* fpFormat */
#endif
);

extern void _PEXExtEncodeVendorExtOC(
#if NeedFunctionPrototypes
    PEXExtOCData *		/* ocSrc */,
    char **			/* ocDest */ 
#endif
);

extern void _PEXExtDecodeVendorExtOC(
#if NeedFunctionPrototypes
    char **			/* ocSrc */,
    PEXExtOCData *		/* ocDest */ 
#endif
);

#endif /* PEXEXTLIBINT_H */

